module Wing
  module Actions
    module Stores
      def list_stores(options = { page: 1, limit: 20, createdBefore: nil, createdAfter: nil })
        get("/store", query: prepare_query(options)).parsed_response
      end

      def create_store(data, options = {})
        post("/store", data, options).parsed_response
      end

      private

      def prepare_query(options = { page: 1, limit: 20, createdBefore: nil, createdAfter: nil })
        {
          page: options[:page],
          limit: options[:limit],
          createdBefore: options[:createdBefore],
          createdAfter: options[:createdAfter],
        }.delete_if { |key, value| value.nil? }
      end
    end
  end
end
